function averageImagesSimpleColor(nome_cartella,first, last, prefix, pattern, postfix,frame_per_secondo,esposizione,tipo)
% AVERAGEIMAGES esegue la media di pi immagini
% le immagini devono essere consistenti per quanto riguarda il nome e la
% dimensione
%
% inputs:
%       nome_cartella: directory in cui sono contenute le immagini
%       first: numero della prima immagine
%       last: numero dell'immagine finale
%       prefix: stringa usata come prefisso al numero delle immagini
%       pattern: stringa formattante per num2str
%       postfix: postfisso al nome del file, solitamente l'estensione
%       frame_per_secondo: numero di frame per secondo di video
%       esposizione: tempo di esposizione delle immagini che si vogliono
%       ottenere
%       tipo:tipo di movimento interessato (0 = foto statica)
% output:
%        scrive n file come immagini a lunga esposizione
%
% example:
%       averageImagesSimpleColor('cartella',1,100,'','%04d','.png',5,2)
% legge 0001.png 0002.png ... 0100.png nella directory 'cartella' e genera
% n file di immagine con 5 secondi di esposizione, nominandoli 5_2_n.png
%


exp=esposizione*frame_per_secondo;
example=imread(strcat(nome_cartella,'/',prefix,num2str(first,pattern),postfix));

%se l'immagine da creare  quella di movimento ne vengono create solo due
if (tipo == 0)
    k=convergent((last-first)/exp)+1;
else
    k=1;
end

s=size(example);

for i=0:k
    
   average=double(zeros(s));
   averagered = double(zeros(s(1),s(2)));
   averagegreen = double(zeros(s(1),s(2)));
   averageblue = double(zeros(s(1),s(2)));

   inizio = ((exp*i)+1)+first;
   fine = ((i+1)*exp)+first;
   if (fine < last+exp && fine >last) 
       fine = last;
   end
   if (inizio < last)
   %viene eseguita la media delle immagini specificate, siddividendo i
   %canali RGB, per conservare le informazioni sul colore
        for j=inizio:fine
            [I]=imread(strcat(nome_cartella,'/',prefix,num2str(j,pattern),postfix));

            red = I(:,:,1);
            green = I(:,:,2);
            blue = I(:,:,3);

            averagered = averagered + double(red);
            averagegreen = averagegreen + double(green);
            averageblue = averageblue + double(blue); 
        end
        
        averagered = averagered./(fine-inizio+1);
        averagegreen = averagegreen./(fine-inizio+1);
        averageblue = averageblue./(fine-inizio+1);
        
        average(:,:,1)=averagered;
        average(:,:,2)=averagegreen;
        average(:,:,3)=averageblue;

        %se l'immagine era statica viene salvato con il nome:
        %esposizione_noise_numero
        if (tipo == 0)
            imwrite(uint8(average),[nome_cartella,'/',int2str(esposizione),'/',int2str(esposizione),'_noise_',int2str(i+1),postfix]);
        %altrimenti viene salvata con il nome:
        %esposizione_movimento_numero
        else
            imwrite(uint8(average),[nome_cartella,'/',int2str(esposizione),'/',int2str(esposizione),'_',int2str(tipo),'_',int2str(i+1),postfix]);
        end
   end
end
